#include <stdarg.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>

#define _MPRINTF_PROTO static
#define _BUFFER_PROTO static

#include "buffer.c"
#include "mprintf.c"

static void (*handler)(void *,char *, size_t);
static buffer_t *buffer;
static void *handler_arg;


void eprintf(const char *fmt, ...)
{
  va_list ap;
  va_start(ap,fmt);
  if (handler)
  {
     vgprintf((void*)handler, handler_arg, fmt, ap);
  }
  else
  {
     if (!buffer) buffer= buffer_new(512);
     vgprintf((void*) buffer_write,buffer, fmt, ap);
  }
  va_end(ap);
}

void eprintf_attach(void (*func)(void *,char *,size_t), void *arg,int action)
{
  char *S; size_t L;

  handler= (void*) func;
  handler_arg= arg;
  if (!buffer) return ;

  if (action=='c')
  {
     buffer_free(buffer, NULL, NULL);
     buffer= NULL;
     return ;
  }

  buffer_free(buffer, (void**) &S, &L);
  (*handler)(handler_arg, S, L);
  free(S);
  buffer= NULL;
}

void eprintf_detach()
{
  handler= NULL;
  handler_arg= NULL;
}
